]> CyberLeo.Net >> Repos - FreeBSD/FreeBSD.git/blob - tests/sys/acl/03.sh
vm: add macro to mark arguments used when NUMA is defined
[FreeBSD/FreeBSD.git] / tests / sys / acl / 03.sh
1 #!/bin/sh
2 #
3 # Copyright (c) 2008, 2009 Edward Tomasz NapieraƂa <trasz@FreeBSD.org>
4 #
5 # Redistribution and use in source and binary forms, with or without
6 # modification, are permitted provided that the following conditions
7 # are met:
8 # 1. Redistributions of source code must retain the above copyright
9 #    notice, this list of conditions and the following disclaimer.
10 # 2. Redistributions in binary form must reproduce the above copyright
11 #    notice, this list of conditions and the following disclaimer in the
12 #    documentation and/or other materials provided with the distribution.
13 #
14 # THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
15 # ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
16 # IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
17 # ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
18 # FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
19 # DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
20 # OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
21 # HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
22 # LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
23 # OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
24 # SUCH DAMAGE.
25 #
26 #
27
28 # This is a wrapper script to run tools-crossfs.test between UFS without
29 # ACLs, UFS with POSIX.1e ACLs, and ZFS with NFSv4 ACLs.
30 #
31 # WARNING: It uses hardcoded ZFS pool name "acltools"
32 #
33 # Output should be obvious.
34
35 if ! sysctl vfs.zfs.version.spa >/dev/null 2>&1; then
36         echo "1..0 # SKIP system doesn't have ZFS loaded"
37         exit 0
38 fi
39 if [ $(id -u) -ne 0 ]; then
40         echo "1..0 # SKIP you must be root"
41         exit 0
42 fi
43 if [ ! -c /dev/mdctl ]; then
44         echo "1..0 # SKIP no /dev/mdctl to create md devices"
45         exit 0
46 fi
47
48 echo "1..5"
49
50 TESTDIR=$(dirname $(realpath $0))
51 MNTROOT=`mktemp -dt acltools`
52
53 # Set up the test filesystems.
54 MD1=`mdconfig -at swap -s 64m`
55 MNT1=$MNTROOT/nfs4
56 mkdir $MNT1
57 zpool create -m $MNT1 acltools /dev/$MD1
58 if [ $? -ne 0 ]; then
59         echo "not ok 1 - 'zpool create' failed."
60         echo 'Bail out!'
61         exit 1
62 fi
63
64 echo "ok 1"
65
66 MD2=`mdconfig -at swap -s 10m`
67 MNT2=$MNTROOT/posix
68 mkdir $MNT2
69 newfs /dev/$MD2 > /dev/null
70 mount -o acls /dev/$MD2 $MNT2
71 if [ $? -ne 0 ]; then
72         echo "not ok 2 - mount failed."
73         echo 'Bail out!'
74         exit 1
75 fi
76
77 echo "ok 2"
78
79 MD3=`mdconfig -at swap -s 10m`
80 MNT3=$MNTROOT/none
81 mkdir $MNT3
82 newfs /dev/$MD3 > /dev/null
83 mount /dev/$MD3 $MNT3
84 if [ $? -ne 0 ]; then
85         echo "not ok 3 - mount failed."
86         echo 'Bail out!'
87         exit 1
88 fi
89
90 echo "ok 3"
91
92 cd $MNTROOT
93
94 perl $TESTDIR/run $TESTDIR/tools-crossfs.test >&2
95
96 if [ $? -eq 0 ]; then
97         echo "ok 4"
98 else
99         echo "not ok 4"
100 fi
101
102 cd /
103
104 umount -f $MNT3
105 rmdir $MNT3
106 mdconfig -du $MD3
107
108 umount -f $MNT2
109 rmdir $MNT2
110 mdconfig -du $MD2
111
112 zpool destroy -f acltools
113 rmdir $MNT1
114 mdconfig -du $MD1
115
116 rmdir $MNTROOT
117
118 echo "ok 5"
119